require_relative "test_helper"

class TestHand < Minitest::Test
  def test_infix_0
    compare_solutions(8, [
      %w{19 23 14 - - 8 - 4 *}
    ], [
      '(19 - (23 - 14) - 8) * 4 = 8'
    ])
  end

  def test_infix_1
    compare_solutions(7, [
      %w{20 19 + 10 + 8 1 - /},
      %w{20 19 10 + + 8 1 - /},
      %w{20 10 * 8 / 19 - 1 +},
      %w{20 10 * 8 / 19 1 - -},
      %w{20 10 * 8 / 1 + 19 -},
      %w{20 10 + 19 + 8 1 - /},
      %w{20 10 19 + + 8 1 - /},
      %w{19 20 + 10 + 8 1 - /},
      %w{19 20 10 + + 8 1 - /},
      %w{19 10 + 20 + 8 1 - /},
      %w{19 10 20 + + 8 1 - /},
      %w{10 20 * 8 / 19 - 1 +},
      %w{10 20 * 8 / 19 1 - -},
      %w{10 20 * 8 / 1 + 19 -},
      %w{10 20 + 19 + 8 1 - /},
      %w{10 20 19 + + 8 1 - /},
      %w{10 19 + 20 + 8 1 - /},
      %w{10 19 20 + + 8 1 - /},
      %w{1 20 10 * 8 / + 19 -},
      %w{1 20 10 * 8 / 19 - +},
      %w{1 10 20 * 8 / + 19 -},
      %w{1 10 20 * 8 / 19 - +}
    ], [
      '(20 + 19 + 10) / (8 - 1) = 7',
      '(20 + (19 + 10)) / (8 - 1) = 7',
      '20 * 10 / 8 - 19 + 1 = 7',
      '20 * 10 / 8 - (19 - 1) = 7',
      '20 * 10 / 8 + 1 - 19 = 7',
      '(20 + 10 + 19) / (8 - 1) = 7',
      '(20 + (10 + 19)) / (8 - 1) = 7',
      '(19 + 20 + 10) / (8 - 1) = 7',
      '(19 + (20 + 10)) / (8 - 1) = 7',
      '(19 + 10 + 20) / (8 - 1) = 7',
      '(19 + (10 + 20)) / (8 - 1) = 7',
      '10 * 20 / 8 - 19 + 1 = 7',
      '10 * 20 / 8 - (19 - 1) = 7',
      '10 * 20 / 8 + 1 - 19 = 7',
      '(10 + 20 + 19) / (8 - 1) = 7',
      '(10 + (20 + 19)) / (8 - 1) = 7',
      '(10 + 19 + 20) / (8 - 1) = 7',
      '(10 + (19 + 20)) / (8 - 1) = 7',
      '1 + 20 * 10 / 8 - 19 = 7',
      '1 + (20 * 10 / 8 - 19) = 7',
      '1 + 10 * 20 / 8 - 19 = 7',
      '1 + (10 * 20 / 8 - 19) = 7'
    ])
  end

  def test_infix_2
    compare_solutions(15, [
      %w{10 7 21 + 25 - * 15 -},
      %w{10 7 25 21 - - * 15 -},
      %w{10 15 7 21 + 25 - / +},
      %w{10 15 7 25 21 - - / +},
      %w{10 15 21 7 + 25 - / +},
      %w{10 15 21 25 7 - - / +},
      %w{10 15 + 25 / 21 + 7 -},
      %w{10 15 + 25 / 21 7 - +},
      %w{10 21 7 + 25 - * 15 -},
      %w{10 21 7 / 25 * 15 / +},
      %w{10 21 25 7 - - * 15 -},
      %w{10 21 25 * 7 15 * / +},
      %w{10 21 25 * 7 / 15 / +},
      %w{10 21 25 * 15 7 * / +},
      %w{10 21 25 * 15 / 7 / +},
      %w{10 25 7 15 * 21 / / +},
      %w{10 25 15 7 * 21 / / +},
      %w{10 25 15 - / 21 + 7 -},
      %w{10 25 15 - / 21 7 - +},
      %w{10 25 15 21 7 / / / +},
      %w{10 25 21 * 7 15 * / +},
      %w{10 25 21 * 7 / 15 / +},
      %w{10 25 21 7 / * 15 / +},
      %w{10 25 21 * 15 7 * / +},
      %w{10 25 21 * 15 / 7 / +},
      %w{7 10 21 + 25 - - 15 *},
      %w{7 10 25 21 - - - 15 *},
      %w{7 15 + 21 - 25 10 - *},
      %w{7 15 + 21 - 25 * 10 -},
      %w{7 21 10 + 25 - - 15 *},
      %w{7 21 15 - - 25 10 - *},
      %w{7 21 15 - - 25 * 10 -},
      %w{7 21 + 25 - 10 * 15 -},
      %w{7 21 25 10 - - - 15 *},
      %w{7 21 + 25 - 15 10 - *},
      %w{7 25 + 10 21 + - 15 *},
      %w{7 25 + 10 - 21 - 15 *},
      %w{7 25 10 - + 21 - 15 *},
      %w{7 25 + 21 10 + - 15 *},
      %w{7 25 + 21 - 10 - 15 *},
      %w{7 25 21 - + 10 - 15 *},
      %w{7 25 21 - - 10 * 15 -},
      %w{7 25 21 - - 15 10 - *},
      %w{15 10 - 7 21 + 25 - *},
      %w{15 10 - 7 25 21 - - *},
      %w{15 10 - 21 7 + 25 - *},
      %w{15 10 - 21 25 7 - - *},
      %w{15 10 + 25 / 21 + 7 -},
      %w{15 10 + 25 / 21 7 - +},
      %w{15 7 10 21 + 25 - - *},
      %w{15 7 10 21 + 25 - - /},
      %w{15 7 10 25 21 - - - *},
      %w{15 7 10 25 21 - - - /},
      %w{15 7 21 10 + 25 - - *},
      %w{15 7 21 10 + 25 - - /},
      %w{15 7 + 21 - 25 10 - *},
      %w{15 7 + 21 - 25 * 10 -},
      %w{15 7 21 + 25 - / 10 +},
      %w{15 7 21 25 10 - - - *},
      %w{15 7 21 25 10 - - - /},
      %w{15 7 25 + 10 21 + - *},
      %w{15 7 25 + 10 21 + - /},
      %w{15 7 25 + 10 - 21 - *},
      %w{15 7 25 + 10 - 21 - /},
      %w{15 7 25 10 - + 21 - *},
      %w{15 7 25 10 - + 21 - /},
      %w{15 7 25 + 21 10 + - *},
      %w{15 7 25 + 21 10 + - /},
      %w{15 7 25 + 21 - 10 - *},
      %w{15 7 25 + 21 - 10 - /},
      %w{15 7 25 21 - + 10 - *},
      %w{15 7 25 21 - + 10 - /},
      %w{15 7 25 21 - - / 10 +},
      %w{15 21 7 + 25 - / 10 +},
      %w{15 21 7 - - 25 10 - *},
      %w{15 21 7 - - 25 * 10 -},
      %w{15 21 25 7 - - / 10 +},
      %w{15 25 10 7 - 21 + - *},
      %w{15 25 10 - 7 + 21 - *},
      %w{15 25 10 7 - 21 + - /},
      %w{15 25 10 - 7 + 21 - /},
      %w{15 25 10 7 - - 21 - *},
      %w{15 25 10 7 - - 21 - /},
      %w{15 25 10 21 + 7 - - *},
      %w{15 25 10 21 + 7 - - /},
      %w{15 25 10 21 7 - + - *},
      %w{15 25 10 21 7 - + - /},
      %w{15 25 10 - 21 7 - - *},
      %w{15 25 10 - 21 7 - - /},
      %w{15 25 10 - / 21 + 7 -},
      %w{15 25 10 - / 21 7 - +},
      %w{15 25 7 + 10 21 + - *},
      %w{15 25 7 + 10 21 + - /},
      %w{15 25 7 + 10 - 21 - *},
      %w{15 25 7 + 10 - 21 - /},
      %w{15 25 7 + 21 10 + - *},
      %w{15 25 7 + 21 10 + - /},
      %w{15 25 7 + 21 - 10 - *},
      %w{15 25 7 + 21 - 10 - /},
      %w{15 25 21 10 + 7 - - *},
      %w{15 25 21 10 + 7 - - /},
      %w{15 25 21 10 7 - + - *},
      %w{15 25 21 10 7 - + - /},
      %w{15 25 21 - 10 7 - - *},
      %w{15 25 21 - 10 7 - - /},
      %w{15 25 21 7 - 10 + - *},
      %w{15 25 21 - 7 + 10 - *},
      %w{15 25 21 7 - 10 + - /},
      %w{15 25 21 - 7 + 10 - /},
      %w{15 25 21 7 - - 10 - *},
      %w{15 25 21 7 - - 10 - /},
      %w{21 10 15 + 25 / + 7 -},
      %w{21 10 25 15 - / + 7 -},
      %w{21 7 10 15 + 25 / - -},
      %w{21 7 - 10 15 + 25 / +},
      %w{21 7 - 10 25 15 - / +},
      %w{21 7 10 25 15 - / - -},
      %w{21 7 15 10 + 25 / - -},
      %w{21 7 - 15 10 + 25 / +},
      %w{21 7 - 15 25 10 - / +},
      %w{21 7 15 25 10 - / - -},
      %w{21 7 + 25 - 10 * 15 -},
      %w{21 7 25 10 15 + / - -},
      %w{21 7 - 25 10 15 + / +},
      %w{21 7 - 25 10 - 15 / +},
      %w{21 7 25 10 - 15 / - -},
      %w{21 7 + 25 - 15 10 - *},
      %w{21 7 25 15 10 + / - -},
      %w{21 7 - 25 15 10 + / +},
      %w{21 7 - 25 15 - 10 / +},
      %w{21 7 25 15 - 10 / - -},
      %w{21 7 / 25 15 10 - / *},
      %w{21 7 / 25 * 15 10 - /},
      %w{21 7 / 25 * 15 / 10 +},
      %w{21 15 10 + 25 / + 7 -},
      %w{21 15 25 10 - / + 7 -},
      %w{21 25 10 15 + / + 7 -},
      %w{21 25 10 - 15 / + 7 -},
      %w{21 25 7 - - 10 * 15 -},
      %w{21 25 7 - - 15 10 - *},
      %w{21 25 * 7 15 10 - * /},
      %w{21 25 * 7 15 * / 10 +},
      %w{21 25 * 7 / 15 10 - /},
      %w{21 25 * 7 / 15 / 10 +},
      %w{21 25 15 10 + / + 7 -},
      %w{21 25 15 - 10 / + 7 -},
      %w{21 25 15 10 - / * 7 /},
      %w{21 25 * 15 10 - 7 * /},
      %w{21 25 * 15 10 - / 7 /},
      %w{21 25 * 15 7 * / 10 +},
      %w{21 25 * 15 / 7 / 10 +},
      %w{25 10 7 15 + 21 - * -},
      %w{25 10 7 15 + 21 - / -},
      %w{25 10 - 7 15 + 21 - *},
      %w{25 10 - 7 15 + 21 - /},
      %w{25 10 - 7 + 21 - 15 *},
      %w{25 10 7 - 21 + - 15 *},
      %w{25 10 7 - - 21 - 15 *},
      %w{25 10 - 7 21 15 - - *},
      %w{25 10 - 7 21 15 - - /},
      %w{25 10 7 21 15 - - * -},
      %w{25 10 7 21 15 - - / -},
      %w{25 10 15 7 + 21 - * -},
      %w{25 10 15 7 + 21 - / -},
      %w{25 10 - 15 7 + 21 - *},
      %w{25 10 - 15 7 + 21 - /},
      %w{25 10 15 + / 21 + 7 -},
      %w{25 10 15 + / 21 7 - +},
      %w{25 10 - 15 21 7 - - *},
      %w{25 10 - 15 21 7 - - /},
      %w{25 10 15 21 7 - - * -},
      %w{25 10 15 21 7 - - / -},
      %w{25 10 - 15 / 21 + 7 -},
      %w{25 10 - 15 / 21 7 - +},
      %w{25 10 21 + 7 - - 15 *},
      %w{25 10 21 7 - + - 15 *},
      %w{25 10 - 21 7 - - 15 *},
      %w{25 7 + 10 21 + - 15 *},
      %w{25 7 + 10 - 21 - 15 *},
      %w{25 7 15 + 21 - * 10 -},
      %w{25 7 15 + 21 - 10 * -},
      %w{25 7 15 + 21 - / 10 -},
      %w{25 7 15 * 21 / / 10 +},
      %w{25 7 + 21 10 + - 15 *},
      %w{25 7 + 21 - 10 - 15 *},
      %w{25 7 21 15 - - 10 * -},
      %w{25 7 21 15 - - * 10 -},
      %w{25 7 21 15 - - / 10 -},
      %w{25 15 10 + / 21 + 7 -},
      %w{25 15 10 + / 21 7 - +},
      %w{25 15 - 10 / 21 + 7 -},
      %w{25 15 - 10 / 21 7 - +},
      %w{25 15 10 - / 21 * 7 /},
      %w{25 15 10 - / 21 7 / *},
      %w{25 15 7 + 21 - * 10 -},
      %w{25 15 7 + 21 - 10 * -},
      %w{25 15 7 + 21 - / 10 -},
      %w{25 15 7 * 21 / / 10 +},
      %w{25 15 21 7 - - 10 * -},
      %w{25 15 21 7 - - * 10 -},
      %w{25 15 21 7 - - / 10 -},
      %w{25 15 21 7 / / / 10 +},
      %w{25 21 10 + 7 - - 15 *},
      %w{25 21 10 7 - + - 15 *},
      %w{25 21 - 10 7 - - 15 *},
      %w{25 21 - 7 + 10 - 15 *},
      %w{25 21 7 - 10 + - 15 *},
      %w{25 21 7 - - 10 - 15 *},
      %w{25 21 * 7 15 10 - * /},
      %w{25 21 * 7 15 * / 10 +},
      %w{25 21 * 7 / 15 10 - /},
      %w{25 21 * 7 / 15 / 10 +},
      %w{25 21 7 / * 15 10 - /},
      %w{25 21 7 / * 15 / 10 +},
      %w{25 21 * 15 10 - 7 * /},
      %w{25 21 * 15 10 - / 7 /},
      %w{25 21 * 15 7 * / 10 +},
      %w{25 21 * 15 / 7 / 10 +}
    ], [
      "10 * (7 + 21 - 25) - 15 = 15",
      "10 * (7 - (25 - 21)) - 15 = 15",
      "10 + 15 / (7 + 21 - 25) = 15",
      "10 + 15 / (7 - (25 - 21)) = 15",
      "10 + 15 / (21 + 7 - 25) = 15",
      "10 + 15 / (21 - (25 - 7)) = 15",
      "(10 + 15) / 25 + 21 - 7 = 15",
      "(10 + 15) / 25 + (21 - 7) = 15",
      "10 * (21 + 7 - 25) - 15 = 15",
      "10 + 21 / 7 * 25 / 15 = 15",
      "10 * (21 - (25 - 7)) - 15 = 15",
      "10 + 21 * 25 / (7 * 15) = 15",
      "10 + 21 * 25 / 7 / 15 = 15",
      "10 + 21 * 25 / (15 * 7) = 15",
      "10 + 21 * 25 / 15 / 7 = 15",
      "10 + 25 / (7 * 15 / 21) = 15",
      "10 + 25 / (15 * 7 / 21) = 15",
      "10 / (25 - 15) + 21 - 7 = 15",
      "10 / (25 - 15) + (21 - 7) = 15",
      "10 + 25 / (15 / (21 / 7)) = 15",
      "10 + 25 * 21 / (7 * 15) = 15",
      "10 + 25 * 21 / 7 / 15 = 15",
      "10 + 25 * (21 / 7) / 15 = 15",
      "10 + 25 * 21 / (15 * 7) = 15",
      "10 + 25 * 21 / 15 / 7 = 15",
      "(7 - (10 + 21 - 25)) * 15 = 15",
      "(7 - (10 - (25 - 21))) * 15 = 15",
      "(7 + 15 - 21) * (25 - 10) = 15",
      "(7 + 15 - 21) * 25 - 10 = 15",
      "(7 - (21 + 10 - 25)) * 15 = 15",
      "(7 - (21 - 15)) * (25 - 10) = 15",
      "(7 - (21 - 15)) * 25 - 10 = 15",
      "(7 + 21 - 25) * 10 - 15 = 15",
      "(7 - (21 - (25 - 10))) * 15 = 15",
      "(7 + 21 - 25) * (15 - 10) = 15",
      "(7 + 25 - (10 + 21)) * 15 = 15",
      "(7 + 25 - 10 - 21) * 15 = 15",
      "(7 + (25 - 10) - 21) * 15 = 15",
      "(7 + 25 - (21 + 10)) * 15 = 15",
      "(7 + 25 - 21 - 10) * 15 = 15",
      "(7 + (25 - 21) - 10) * 15 = 15",
      "(7 - (25 - 21)) * 10 - 15 = 15",
      "(7 - (25 - 21)) * (15 - 10) = 15",
      "(15 - 10) * (7 + 21 - 25) = 15",
      "(15 - 10) * (7 - (25 - 21)) = 15",
      "(15 - 10) * (21 + 7 - 25) = 15",
      "(15 - 10) * (21 - (25 - 7)) = 15",
      "(15 + 10) / 25 + 21 - 7 = 15",
      "(15 + 10) / 25 + (21 - 7) = 15",
      "15 * (7 - (10 + 21 - 25)) = 15",
      "15 / (7 - (10 + 21 - 25)) = 15",
      "15 * (7 - (10 - (25 - 21))) = 15",
      "15 / (7 - (10 - (25 - 21))) = 15",
      "15 * (7 - (21 + 10 - 25)) = 15",
      "15 / (7 - (21 + 10 - 25)) = 15",
      "(15 + 7 - 21) * (25 - 10) = 15",
      "(15 + 7 - 21) * 25 - 10 = 15",
      "15 / (7 + 21 - 25) + 10 = 15",
      "15 * (7 - (21 - (25 - 10))) = 15",
      "15 / (7 - (21 - (25 - 10))) = 15",
      "15 * (7 + 25 - (10 + 21)) = 15",
      "15 / (7 + 25 - (10 + 21)) = 15",
      "15 * (7 + 25 - 10 - 21) = 15",
      "15 / (7 + 25 - 10 - 21) = 15",
      "15 * (7 + (25 - 10) - 21) = 15",
      "15 / (7 + (25 - 10) - 21) = 15",
      "15 * (7 + 25 - (21 + 10)) = 15",
      "15 / (7 + 25 - (21 + 10)) = 15",
      "15 * (7 + 25 - 21 - 10) = 15",
      "15 / (7 + 25 - 21 - 10) = 15",
      "15 * (7 + (25 - 21) - 10) = 15",
      "15 / (7 + (25 - 21) - 10) = 15",
      "15 / (7 - (25 - 21)) + 10 = 15",
      "15 / (21 + 7 - 25) + 10 = 15",
      "(15 - (21 - 7)) * (25 - 10) = 15",
      "(15 - (21 - 7)) * 25 - 10 = 15",
      "15 / (21 - (25 - 7)) + 10 = 15",
      "15 * (25 - (10 - 7 + 21)) = 15",
      "15 * (25 - 10 + 7 - 21) = 15",
      "15 / (25 - (10 - 7 + 21)) = 15",
      "15 / (25 - 10 + 7 - 21) = 15",
      "15 * (25 - (10 - 7) - 21) = 15",
      "15 / (25 - (10 - 7) - 21) = 15",
      "15 * (25 - (10 + 21 - 7)) = 15",
      "15 / (25 - (10 + 21 - 7)) = 15",
      "15 * (25 - (10 + (21 - 7))) = 15",
      "15 / (25 - (10 + (21 - 7))) = 15",
      "15 * (25 - 10 - (21 - 7)) = 15",
      "15 / (25 - 10 - (21 - 7)) = 15",
      "15 / (25 - 10) + 21 - 7 = 15",
      "15 / (25 - 10) + (21 - 7) = 15",
      "15 * (25 + 7 - (10 + 21)) = 15",
      "15 / (25 + 7 - (10 + 21)) = 15",
      "15 * (25 + 7 - 10 - 21) = 15",
      "15 / (25 + 7 - 10 - 21) = 15",
      "15 * (25 + 7 - (21 + 10)) = 15",
      "15 / (25 + 7 - (21 + 10)) = 15",
      "15 * (25 + 7 - 21 - 10) = 15",
      "15 / (25 + 7 - 21 - 10) = 15",
      "15 * (25 - (21 + 10 - 7)) = 15",
      "15 / (25 - (21 + 10 - 7)) = 15",
      "15 * (25 - (21 + (10 - 7))) = 15",
      "15 / (25 - (21 + (10 - 7))) = 15",
      "15 * (25 - 21 - (10 - 7)) = 15",
      "15 / (25 - 21 - (10 - 7)) = 15",
      "15 * (25 - (21 - 7 + 10)) = 15",
      "15 * (25 - 21 + 7 - 10) = 15",
      "15 / (25 - (21 - 7 + 10)) = 15",
      "15 / (25 - 21 + 7 - 10) = 15",
      "15 * (25 - (21 - 7) - 10) = 15",
      "15 / (25 - (21 - 7) - 10) = 15",
      "21 + (10 + 15) / 25 - 7 = 15",
      "21 + 10 / (25 - 15) - 7 = 15",
      "21 - (7 - (10 + 15) / 25) = 15",
      "21 - 7 + (10 + 15) / 25 = 15",
      "21 - 7 + 10 / (25 - 15) = 15",
      "21 - (7 - 10 / (25 - 15)) = 15",
      "21 - (7 - (15 + 10) / 25) = 15",
      "21 - 7 + (15 + 10) / 25 = 15",
      "21 - 7 + 15 / (25 - 10) = 15",
      "21 - (7 - 15 / (25 - 10)) = 15",
      "(21 + 7 - 25) * 10 - 15 = 15",
      "21 - (7 - 25 / (10 + 15)) = 15",
      "21 - 7 + 25 / (10 + 15) = 15",
      "21 - 7 + (25 - 10) / 15 = 15",
      "21 - (7 - (25 - 10) / 15) = 15",
      "(21 + 7 - 25) * (15 - 10) = 15",
      "21 - (7 - 25 / (15 + 10)) = 15",
      "21 - 7 + 25 / (15 + 10) = 15",
      "21 - 7 + (25 - 15) / 10 = 15",
      "21 - (7 - (25 - 15) / 10) = 15",
      "21 / 7 * (25 / (15 - 10)) = 15",
      "21 / 7 * 25 / (15 - 10) = 15",
      "21 / 7 * 25 / 15 + 10 = 15",
      "21 + (15 + 10) / 25 - 7 = 15",
      "21 + 15 / (25 - 10) - 7 = 15",
      "21 + 25 / (10 + 15) - 7 = 15",
      "21 + (25 - 10) / 15 - 7 = 15",
      "(21 - (25 - 7)) * 10 - 15 = 15",
      "(21 - (25 - 7)) * (15 - 10) = 15",
      "21 * 25 / (7 * (15 - 10)) = 15",
      "21 * 25 / (7 * 15) + 10 = 15",
      "21 * 25 / 7 / (15 - 10) = 15",
      "21 * 25 / 7 / 15 + 10 = 15",
      "21 + 25 / (15 + 10) - 7 = 15",
      "21 + (25 - 15) / 10 - 7 = 15",
      "21 * (25 / (15 - 10)) / 7 = 15",
      "21 * 25 / ((15 - 10) * 7) = 15",
      "21 * 25 / (15 - 10) / 7 = 15",
      "21 * 25 / (15 * 7) + 10 = 15",
      "21 * 25 / 15 / 7 + 10 = 15",
      "25 - 10 * (7 + 15 - 21) = 15",
      "25 - 10 / (7 + 15 - 21) = 15",
      "(25 - 10) * (7 + 15 - 21) = 15",
      "(25 - 10) / (7 + 15 - 21) = 15",
      "(25 - 10 + 7 - 21) * 15 = 15",
      "(25 - (10 - 7 + 21)) * 15 = 15",
      "(25 - (10 - 7) - 21) * 15 = 15",
      "(25 - 10) * (7 - (21 - 15)) = 15",
      "(25 - 10) / (7 - (21 - 15)) = 15",
      "25 - 10 * (7 - (21 - 15)) = 15",
      "25 - 10 / (7 - (21 - 15)) = 15",
      "25 - 10 * (15 + 7 - 21) = 15",
      "25 - 10 / (15 + 7 - 21) = 15",
      "(25 - 10) * (15 + 7 - 21) = 15",
      "(25 - 10) / (15 + 7 - 21) = 15",
      "25 / (10 + 15) + 21 - 7 = 15",
      "25 / (10 + 15) + (21 - 7) = 15",
      "(25 - 10) * (15 - (21 - 7)) = 15",
      "(25 - 10) / (15 - (21 - 7)) = 15",
      "25 - 10 * (15 - (21 - 7)) = 15",
      "25 - 10 / (15 - (21 - 7)) = 15",
      "(25 - 10) / 15 + 21 - 7 = 15",
      "(25 - 10) / 15 + (21 - 7) = 15",
      "(25 - (10 + 21 - 7)) * 15 = 15",
      "(25 - (10 + (21 - 7))) * 15 = 15",
      "(25 - 10 - (21 - 7)) * 15 = 15",
      "(25 + 7 - (10 + 21)) * 15 = 15",
      "(25 + 7 - 10 - 21) * 15 = 15",
      "25 * (7 + 15 - 21) - 10 = 15",
      "25 - (7 + 15 - 21) * 10 = 15",
      "25 / (7 + 15 - 21) - 10 = 15",
      "25 / (7 * 15 / 21) + 10 = 15",
      "(25 + 7 - (21 + 10)) * 15 = 15",
      "(25 + 7 - 21 - 10) * 15 = 15",
      "25 - (7 - (21 - 15)) * 10 = 15",
      "25 * (7 - (21 - 15)) - 10 = 15",
      "25 / (7 - (21 - 15)) - 10 = 15",
      "25 / (15 + 10) + 21 - 7 = 15",
      "25 / (15 + 10) + (21 - 7) = 15",
      "(25 - 15) / 10 + 21 - 7 = 15",
      "(25 - 15) / 10 + (21 - 7) = 15",
      "25 / (15 - 10) * 21 / 7 = 15",
      "25 / (15 - 10) * (21 / 7) = 15",
      "25 * (15 + 7 - 21) - 10 = 15",
      "25 - (15 + 7 - 21) * 10 = 15",
      "25 / (15 + 7 - 21) - 10 = 15",
      "25 / (15 * 7 / 21) + 10 = 15",
      "25 - (15 - (21 - 7)) * 10 = 15",
      "25 * (15 - (21 - 7)) - 10 = 15",
      "25 / (15 - (21 - 7)) - 10 = 15",
      "25 / (15 / (21 / 7)) + 10 = 15",
      "(25 - (21 + 10 - 7)) * 15 = 15",
      "(25 - (21 + (10 - 7))) * 15 = 15",
      "(25 - 21 - (10 - 7)) * 15 = 15",
      "(25 - 21 + 7 - 10) * 15 = 15",
      "(25 - (21 - 7 + 10)) * 15 = 15",
      "(25 - (21 - 7) - 10) * 15 = 15",
      "25 * 21 / (7 * (15 - 10)) = 15",
      "25 * 21 / (7 * 15) + 10 = 15",
      "25 * 21 / 7 / (15 - 10) = 15",
      "25 * 21 / 7 / 15 + 10 = 15",
      "25 * (21 / 7) / (15 - 10) = 15",
      "25 * (21 / 7) / 15 + 10 = 15",
      "25 * 21 / ((15 - 10) * 7) = 15",
      "25 * 21 / (15 - 10) / 7 = 15",
      "25 * 21 / (15 * 7) + 10 = 15",
      "25 * 21 / 15 / 7 + 10 = 15"
    ])
  end

  private

  def compare_solutions(target, actual_exprs, expected_exprs)
    solution = make_solution(target, actual_exprs)

    expected_exprs.zip(solution.infix).each_with_index do |(expected, expr), index|
      assert_equal expected, expr, "Wrong value in index #{index}"
    end
  end

  def make_solution(target, postfixes)
    solution = Rypto::Solution.new target

    postfixes.each do |postfix|
      expr = postfix.map {|e| e.to_i > 0 ? e.to_i : e}
      solution.push expr
    end

    solution
  end
end
